<template>
  <section class="grid grid-cols-12 gap-4">
    <section class="col-span-12 md:col-span-6">
      <span class="block text-gray-500 pb-1">
        Взрослые
      </span>

      <NumberInput
        v-model="adults"
        mode="integer"
        :min="0"
        :max="INT_SIZE"
        :step="1"
      />
    </section>

    <section class="col-span-12 md:col-span-6">
      <span class="block text-gray-500 pb-1">
        Дети
      </span>

      <NumberInput
        v-model="children"
        mode="integer"
        :min="0"
        :max="INT_SIZE"
        :step="1"
      />
    </section>
  </section>

  <v-scroll-y-transition>
    <v-alert
      icon="mdi-information-outline"
      class="mt-4 text-teal-600 bg-teal-50 border-2 border-teal-100"
      closable
    >
      Расчет по тарифу производится только для взрослых гостей
    </v-alert>
  </v-scroll-y-transition>

  <v-scroll-y-transition>
    <v-alert
      v-if="isCapacityExceedShown && property"
      icon="mdi-alert-outline"
      class="mt-4 text-yellow-600 bg-yellow-50 border-2 border-yellow-100"
    >
      Указанное число гостей (<b>{{ adults + children }}</b>) превышает максимальную
      вместимость выбранного объекта (<b>{{ property.capacity }}</b>)
    </v-alert>
  </v-scroll-y-transition>

  <v-select
    v-model="contact"
    label="Контактное лицо"
    :items="guests"
    :loading="isLoading"
    class="mt-4"
    hide-details
    return-object
    @update:focused="onFocus"
  >
    <template #prepend-item>
      <section class="p-3">
        <v-text-field
          :clearable="!isLoading"
          flat
          variant="solo-filled"
          prepend-inner-icon="mdi-magnify"
          placeholder="Поиск"
          type="input"
          hide-details
          density="comfortable"
          @input="onSearchInput"
          @click:clear="term = ''"
        >
          <template #append-inner>
            <v-btn
              v-tooltip:left="{ text: `Минимум символов: ${MIN_SEARCH_TERM_LENGTH}`, openOnClick: true }"
              icon="mdi-shield-alert-outline"
              variant="plain"
              size="small"
              :ripple="false"
            />
          </template>
        </v-text-field>
      </section>
    </template>

    <template #item="{ item, props: itemProps }">
      <!--Leave title empty to fix vue warnings-->
      <v-list-item
        v-bind="itemProps"
        title=""
        class="py-2"
      >
        <template #title>
          <section class="flex items-center gap-2">
            <v-icon icon="mdi-account-outline" />

            <section>
              {{ item.value.name }}
            </section>
          </section>
        </template>

        <template #subtitle>
          <section class="pt-2 ml-8">
            <span v-if="item.value.phones.at(0)">
              {{ getFormattedPhoneNumber(item.value.phones.at(0).value!) }}
            </span>

            <span v-else>
              Номер телефона не указан
            </span>
          </section>
        </template>
      </v-list-item>
    </template>

    <template #selection="{ item }">
      <section class="flex items-center gap-2">
        <v-icon icon="mdi-account-outline" />

        <section>
          {{ item.value.name }}
        </section>
      </section>
    </template>

    <template #append-item>
      <InlineLoadingIndicator
        v-if="isLoading"
        embedded
      />

      <div
        v-intersect="onFullyScrolled"
        class="h-4"
      />
    </template>

    <template #no-data>
      <EmptyState
        v-if="!isLoading && !guests.length"
        embedded
      />
    </template>
  </v-select>

  <v-scroll-y-transition>
    <section v-if="contact?.phones?.length">
      <section class="mt-2 text-lg font-light text-gray-500">
        Номера телефонов
      </section>

      <v-list lines="one">
        <v-list-item
          v-for="(phone, index) in contact.phones"
          :key="phone.id"
          :title="getFormattedPhoneNumber(phone.value)"
          :class="{ 'bg-gray-100': index % 2 === 0 }"
          prepend-icon="mdi-text-short"
        />
      </v-list>
    </section>
  </v-scroll-y-transition>

  <v-scroll-y-transition>
    <section v-if="contact?.notes?.length">
      <section class="mt-2 text-lg font-light text-gray-500">
        Заметки
      </section>

      <v-list lines="one">
        <v-list-item
          v-for="(note, index) in contact.notes"
          :key="note.id"
          class="[&_.v-list-item-title]:whitespace-normal"
          :class="{ 'bg-gray-100': index % 2 === 0 }"
          :title="note.text"
          prepend-icon="mdi-text-short"
        />
      </v-list>
    </section>
  </v-scroll-y-transition>
</template>

<script setup lang="ts">
import { computed, ref, watch } from 'vue';
import { VSelect, VTextField } from 'vuetify/components';

import { HttpClient } from '@/http';
import { usePagination } from '@/composables';

import { INT_SIZE, MIN_SEARCH_TERM_LENGTH } from '@/declarations';
import { debounce, getFormattedPhoneNumber } from '@/utils';

import EmptyState from '@/components/layout/EmptyState.vue';
import InlineLoadingIndicator from '@/components/layout/InlineLoadingIndicator.vue';
import NumberInput from '@/components/content/NumberInput.vue';

const props = defineProps<{ property: IProperty | null }>();

const GUESTS_LIST_SIZE = 10;

const pagination = usePagination({ size: GUESTS_LIST_SIZE });

const guests = ref<IGuest[]>([]);

const contact = defineModel<IGuest | null>('contact');
const adults = defineModel<number>('adults', { default: 0 });
const children = defineModel<number>('children', { default: 0 });

const term = ref('');
const isLoading = ref(false);

const isCapacityExceedShown = computed(() => {
  if (!props.property) return false;

  const maxCapacity = props.property.capacity;
  const currentGuestsCount = adults.value + children.value;

  return currentGuestsCount > maxCapacity;
});

const onFocus = async (isFocused: boolean) => {
  if (!isFocused || isLoading.value) {
    return;
  }

  await fetchData({ reset: true });
};

const onSearchInput = debounce(500, (event: InputEvent) => {
  const target = event.target as HTMLInputElement;
  const value = target.value;

  const currentTerm = value?.trim() ?? '';

  if (currentTerm && currentTerm.length < MIN_SEARCH_TERM_LENGTH) {
    return;
  }

  term.value = currentTerm;
});

const onFullyScrolled = (isIntersecting: boolean) => {
  const isDataLoaded = (
    guests.value.length < GUESTS_LIST_SIZE
  );

  if (!isIntersecting || isDataLoaded) {
    return;
  }

  fetchData({ reset: false });
};

const fetchData = async (options: Partial<PageFetchDataOptions>) => {
  isLoading.value = true;

  if (options.reset) pagination.resetPage();
  if (!options.reset) pagination.nextPage();

  const response = await HttpClient.get<IGuest[]>('/v1/guests', {
    params: {
      limit: GUESTS_LIST_SIZE,
      offset: pagination.offset.value,
      ...(term.value && { term: term.value }),
    },
  });

  isLoading.value = false;

  if (!response.data.values) {
    return;
  }

  guests.value = options.reset
    ? response.data.values
    : [...guests.value, ...response.data.values];
};

watch(term, () => fetchData({ reset: true }));
</script>